git-rebase.shon commit git add -p: add missing "q" to patch prompt (a2fc8d6)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano.
   4#
   5
   6USAGE='[--interactive | -i] [-v] [--onto <newbase>] [<upstream>|--root] [<branch>]'
   7LONG_USAGE='git-rebase replaces <branch> with a new branch of the
   8same name.  When the --onto option is provided the new branch starts
   9out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
  10It then attempts to create a new commit for each commit from the original
  11<branch> that does not exist in the <upstream> branch.
  12
  13It is possible that a merge failure will prevent this process from being
  14completely automatic.  You will have to resolve any such merge failure
  15and run git rebase --continue.  Another option is to bypass the commit
  16that caused the merge failure with git rebase --skip.  To restore the
  17original <branch> and remove the .git/rebase-apply working files, use the
  18command git rebase --abort instead.
  19
  20Note that if <branch> is not specified on the command line, the
  21currently checked out branch is used.
  22
  23Example:       git-rebase master~1 topic
  24
  25        A---B---C topic                   A'\''--B'\''--C'\'' topic
  26       /                   -->           /
  27  D---E---F---G master          D---E---F---G master
  28'
  29
  30SUBDIRECTORY_OK=Yes
  31OPTIONS_SPEC=
  32. git-sh-setup
  33set_reflog_action rebase
  34require_work_tree
  35cd_to_toplevel
  36
  37OK_TO_SKIP_PRE_REBASE=
  38RESOLVEMSG="
  39When you have resolved this problem run \"git rebase --continue\".
  40If you would prefer to skip this patch, instead run \"git rebase --skip\".
  41To restore the original branch and stop rebasing run \"git rebase --abort\".
  42"
  43unset newbase
  44strategy=recursive
  45do_merge=
  46dotest="$GIT_DIR"/rebase-merge
  47prec=4
  48verbose=
  49git_am_opt=
  50rebase_root=
  51
  52continue_merge () {
  53        test -n "$prev_head" || die "prev_head must be defined"
  54        test -d "$dotest" || die "$dotest directory does not exist"
  55
  56        unmerged=$(git ls-files -u)
  57        if test -n "$unmerged"
  58        then
  59                echo "You still have unmerged paths in your index"
  60                echo "did you forget to use git add?"
  61                die "$RESOLVEMSG"
  62        fi
  63
  64        cmt=`cat "$dotest/current"`
  65        if ! git diff-index --quiet --ignore-submodules HEAD --
  66        then
  67                if ! git commit --no-verify -C "$cmt"
  68                then
  69                        echo "Commit failed, please do not call \"git commit\""
  70                        echo "directly, but instead do one of the following: "
  71                        die "$RESOLVEMSG"
  72                fi
  73                printf "Committed: %0${prec}d " $msgnum
  74        else
  75                printf "Already applied: %0${prec}d " $msgnum
  76        fi
  77        git rev-list --pretty=oneline -1 "$cmt" | sed -e 's/^[^ ]* //'
  78
  79        prev_head=`git rev-parse HEAD^0`
  80        # save the resulting commit so we can read-tree on it later
  81        echo "$prev_head" > "$dotest/prev_head"
  82
  83        # onto the next patch:
  84        msgnum=$(($msgnum + 1))
  85        echo "$msgnum" >"$dotest/msgnum"
  86}
  87
  88call_merge () {
  89        cmt="$(cat "$dotest/cmt.$1")"
  90        echo "$cmt" > "$dotest/current"
  91        hd=$(git rev-parse --verify HEAD)
  92        cmt_name=$(git symbolic-ref HEAD 2> /dev/null || echo HEAD)
  93        msgnum=$(cat "$dotest/msgnum")
  94        end=$(cat "$dotest/end")
  95        eval GITHEAD_$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
  96        eval GITHEAD_$hd='$(cat "$dotest/onto_name")'
  97        export GITHEAD_$cmt GITHEAD_$hd
  98        git-merge-$strategy "$cmt^" -- "$hd" "$cmt"
  99        rv=$?
 100        case "$rv" in
 101        0)
 102                unset GITHEAD_$cmt GITHEAD_$hd
 103                return
 104                ;;
 105        1)
 106                git rerere
 107                die "$RESOLVEMSG"
 108                ;;
 109        2)
 110                echo "Strategy: $rv $strategy failed, try another" 1>&2
 111                die "$RESOLVEMSG"
 112                ;;
 113        *)
 114                die "Unknown exit code ($rv) from command:" \
 115                        "git-merge-$strategy $cmt^ -- HEAD $cmt"
 116                ;;
 117        esac
 118}
 119
 120move_to_original_branch () {
 121        test -z "$head_name" &&
 122                head_name="$(cat "$dotest"/head-name)" &&
 123                onto="$(cat "$dotest"/onto)" &&
 124                orig_head="$(cat "$dotest"/orig-head)"
 125        case "$head_name" in
 126        refs/*)
 127                message="rebase finished: $head_name onto $onto"
 128                git update-ref -m "$message" \
 129                        $head_name $(git rev-parse HEAD) $orig_head &&
 130                git symbolic-ref HEAD $head_name ||
 131                die "Could not move back to $head_name"
 132                ;;
 133        esac
 134}
 135
 136finish_rb_merge () {
 137        move_to_original_branch
 138        rm -r "$dotest"
 139        echo "All done."
 140}
 141
 142is_interactive () {
 143        while test $# != 0
 144        do
 145                case "$1" in
 146                        -i|--interactive)
 147                                interactive_rebase=explicit
 148                                break
 149                        ;;
 150                        -p|--preserve-merges)
 151                                interactive_rebase=implied
 152                        ;;
 153                esac
 154                shift
 155        done
 156
 157        if [ "$interactive_rebase" = implied ]; then
 158                GIT_EDITOR=:
 159                export GIT_EDITOR
 160        fi
 161
 162        test -n "$interactive_rebase" || test -f "$dotest"/interactive
 163}
 164
 165run_pre_rebase_hook () {
 166        if test -z "$OK_TO_SKIP_PRE_REBASE" &&
 167           test -x "$GIT_DIR/hooks/pre-rebase"
 168        then
 169                "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} || {
 170                        echo >&2 "The pre-rebase hook refused to rebase."
 171                        exit 1
 172                }
 173        fi
 174}
 175
 176test -f "$GIT_DIR"/rebase-apply/applying &&
 177        die 'It looks like git-am is in progress. Cannot rebase.'
 178
 179is_interactive "$@" && exec git-rebase--interactive "$@"
 180
 181if test $# -eq 0
 182then
 183        test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply || usage
 184        test -d "$dotest" -o -f "$GIT_DIR"/rebase-apply/rebasing &&
 185                die 'A rebase is in progress, try --continue, --skip or --abort.'
 186        die "No arguments given and $GIT_DIR/rebase-apply already exists."
 187fi
 188
 189while test $# != 0
 190do
 191        case "$1" in
 192        --no-verify)
 193                OK_TO_SKIP_PRE_REBASE=yes
 194                ;;
 195        --continue)
 196                test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
 197                        die "No rebase in progress?"
 198
 199                git diff-files --quiet --ignore-submodules || {
 200                        echo "You must edit all merge conflicts and then"
 201                        echo "mark them as resolved using git add"
 202                        exit 1
 203                }
 204                if test -d "$dotest"
 205                then
 206                        prev_head=$(cat "$dotest/prev_head")
 207                        end=$(cat "$dotest/end")
 208                        msgnum=$(cat "$dotest/msgnum")
 209                        onto=$(cat "$dotest/onto")
 210                        continue_merge
 211                        while test "$msgnum" -le "$end"
 212                        do
 213                                call_merge "$msgnum"
 214                                continue_merge
 215                        done
 216                        finish_rb_merge
 217                        exit
 218                fi
 219                head_name=$(cat "$GIT_DIR"/rebase-apply/head-name) &&
 220                onto=$(cat "$GIT_DIR"/rebase-apply/onto) &&
 221                orig_head=$(cat "$GIT_DIR"/rebase-apply/orig-head) &&
 222                git am --resolved --3way --resolvemsg="$RESOLVEMSG" &&
 223                move_to_original_branch
 224                exit
 225                ;;
 226        --skip)
 227                test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
 228                        die "No rebase in progress?"
 229
 230                git reset --hard HEAD || exit $?
 231                if test -d "$dotest"
 232                then
 233                        git rerere clear
 234                        prev_head=$(cat "$dotest/prev_head")
 235                        end=$(cat "$dotest/end")
 236                        msgnum=$(cat "$dotest/msgnum")
 237                        msgnum=$(($msgnum + 1))
 238                        onto=$(cat "$dotest/onto")
 239                        while test "$msgnum" -le "$end"
 240                        do
 241                                call_merge "$msgnum"
 242                                continue_merge
 243                        done
 244                        finish_rb_merge
 245                        exit
 246                fi
 247                head_name=$(cat "$GIT_DIR"/rebase-apply/head-name) &&
 248                onto=$(cat "$GIT_DIR"/rebase-apply/onto) &&
 249                orig_head=$(cat "$GIT_DIR"/rebase-apply/orig-head) &&
 250                git am -3 --skip --resolvemsg="$RESOLVEMSG" &&
 251                move_to_original_branch
 252                exit
 253                ;;
 254        --abort)
 255                test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
 256                        die "No rebase in progress?"
 257
 258                git rerere clear
 259                if test -d "$dotest"
 260                then
 261                        move_to_original_branch
 262                else
 263                        dotest="$GIT_DIR"/rebase-apply
 264                        move_to_original_branch
 265                fi
 266                git reset --hard $(cat "$dotest/orig-head")
 267                rm -r "$dotest"
 268                exit
 269                ;;
 270        --onto)
 271                test 2 -le "$#" || usage
 272                newbase="$2"
 273                shift
 274                ;;
 275        -M|-m|--m|--me|--mer|--merg|--merge)
 276                do_merge=t
 277                ;;
 278        -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
 279                --strateg=*|--strategy=*|\
 280        -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
 281                case "$#,$1" in
 282                *,*=*)
 283                        strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
 284                1,*)
 285                        usage ;;
 286                *)
 287                        strategy="$2"
 288                        shift ;;
 289                esac
 290                do_merge=t
 291                ;;
 292        -v|--verbose)
 293                verbose=t
 294                ;;
 295        --whitespace=*)
 296                git_am_opt="$git_am_opt $1"
 297                ;;
 298        -C*)
 299                git_am_opt="$git_am_opt $1"
 300                ;;
 301        --root)
 302                rebase_root=t
 303                ;;
 304        -*)
 305                usage
 306                ;;
 307        *)
 308                break
 309                ;;
 310        esac
 311        shift
 312done
 313test $# -gt 2 && usage
 314
 315# Make sure we do not have $GIT_DIR/rebase-apply
 316if test -z "$do_merge"
 317then
 318        if mkdir "$GIT_DIR"/rebase-apply 2>/dev/null
 319        then
 320                rmdir "$GIT_DIR"/rebase-apply
 321        else
 322                echo >&2 '
 323It seems that I cannot create a rebase-apply directory, and
 324I wonder if you are in the middle of patch application or another
 325rebase.  If that is not the case, please
 326        rm -fr '"$GIT_DIR"'/rebase-apply
 327and run me again.  I am stopping in case you still have something
 328valuable there.'
 329                exit 1
 330        fi
 331else
 332        if test -d "$dotest"
 333        then
 334                die "previous rebase directory $dotest still exists." \
 335                        'Try git rebase (--continue | --abort | --skip)'
 336        fi
 337fi
 338
 339# The tree must be really really clean.
 340if ! git update-index --ignore-submodules --refresh; then
 341        echo >&2 "cannot rebase: you have unstaged changes"
 342        exit 1
 343fi
 344diff=$(git diff-index --cached --name-status -r --ignore-submodules HEAD --)
 345case "$diff" in
 346?*)     echo >&2 "cannot rebase: your index contains uncommitted changes"
 347        echo >&2 "$diff"
 348        exit 1
 349        ;;
 350esac
 351
 352if test -z "$rebase_root"
 353then
 354        # The upstream head must be given.  Make sure it is valid.
 355        upstream_name="$1"
 356        shift
 357        upstream=`git rev-parse --verify "${upstream_name}^0"` ||
 358        die "invalid upstream $upstream_name"
 359        unset root_flag
 360        upstream_arg="$upstream_name"
 361else
 362        test -z "$newbase" && die "--root must be used with --onto"
 363        unset upstream_name
 364        unset upstream
 365        root_flag="--root"
 366        upstream_arg="$root_flag"
 367fi
 368
 369# Make sure the branch to rebase onto is valid.
 370onto_name=${newbase-"$upstream_name"}
 371onto=$(git rev-parse --verify "${onto_name}^0") || exit
 372
 373# If a hook exists, give it a chance to interrupt
 374run_pre_rebase_hook "$upstream_arg" "$@"
 375
 376# If the branch to rebase is given, that is the branch we will rebase
 377# $branch_name -- branch being rebased, or HEAD (already detached)
 378# $orig_head -- commit object name of tip of the branch before rebasing
 379# $head_name -- refs/heads/<that-branch> or "detached HEAD"
 380switch_to=
 381case "$#" in
 3821)
 383        # Is it "rebase other $branchname" or "rebase other $commit"?
 384        branch_name="$1"
 385        switch_to="$1"
 386
 387        if git show-ref --verify --quiet -- "refs/heads/$1" &&
 388           branch=$(git rev-parse -q --verify "refs/heads/$1")
 389        then
 390                head_name="refs/heads/$1"
 391        elif branch=$(git rev-parse -q --verify "$1")
 392        then
 393                head_name="detached HEAD"
 394        else
 395                usage
 396        fi
 397        ;;
 398*)
 399        # Do not need to switch branches, we are already on it.
 400        if branch_name=`git symbolic-ref -q HEAD`
 401        then
 402                head_name=$branch_name
 403                branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
 404        else
 405                head_name="detached HEAD"
 406                branch_name=HEAD ;# detached
 407        fi
 408        branch=$(git rev-parse --verify "${branch_name}^0") || exit
 409        ;;
 410esac
 411orig_head=$branch
 412
 413# Now we are rebasing commits $upstream..$branch (or with --root,
 414# everything leading up to $branch) on top of $onto
 415
 416# Check if we are already based on $onto with linear history,
 417# but this should be done only when upstream and onto are the same.
 418mb=$(git merge-base "$onto" "$branch")
 419if test "$upstream" = "$onto" && test "$mb" = "$onto" &&
 420        # linear history?
 421        ! (git rev-list --parents "$onto".."$branch" | grep " .* ") > /dev/null
 422then
 423        # Lazily switch to the target branch if needed...
 424        test -z "$switch_to" || git checkout "$switch_to"
 425        echo >&2 "Current branch $branch_name is up to date."
 426        exit 0
 427fi
 428
 429if test -n "$verbose"
 430then
 431        echo "Changes from $mb to $onto:"
 432        # We want color (if set), but no pager
 433        GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
 434fi
 435
 436# Detach HEAD and reset the tree
 437echo "First, rewinding head to replay your work on top of it..."
 438git checkout -q "$onto^0" || die "could not detach HEAD"
 439git update-ref ORIG_HEAD $branch
 440
 441# If the $onto is a proper descendant of the tip of the branch, then
 442# we just fast forwarded.
 443if test "$mb" = "$branch"
 444then
 445        echo >&2 "Fast-forwarded $branch_name to $onto_name."
 446        move_to_original_branch
 447        exit 0
 448fi
 449
 450if test -n "$rebase_root"
 451then
 452        revisions="$onto..$orig_head"
 453else
 454        revisions="$upstream..$orig_head"
 455fi
 456
 457if test -z "$do_merge"
 458then
 459        git format-patch -k --stdout --full-index --ignore-if-in-upstream \
 460                $root_flag "$revisions" |
 461        git am $git_am_opt --rebasing --resolvemsg="$RESOLVEMSG" &&
 462        move_to_original_branch
 463        ret=$?
 464        test 0 != $ret -a -d "$GIT_DIR"/rebase-apply &&
 465                echo $head_name > "$GIT_DIR"/rebase-apply/head-name &&
 466                echo $onto > "$GIT_DIR"/rebase-apply/onto &&
 467                echo $orig_head > "$GIT_DIR"/rebase-apply/orig-head
 468        exit $ret
 469fi
 470
 471# start doing a rebase with git-merge
 472# this is rename-aware if the recursive (default) strategy is used
 473
 474mkdir -p "$dotest"
 475echo "$onto" > "$dotest/onto"
 476echo "$onto_name" > "$dotest/onto_name"
 477prev_head=$orig_head
 478echo "$prev_head" > "$dotest/prev_head"
 479echo "$orig_head" > "$dotest/orig-head"
 480echo "$head_name" > "$dotest/head-name"
 481
 482msgnum=0
 483for cmt in `git rev-list --reverse --no-merges "$revisions"`
 484do
 485        msgnum=$(($msgnum + 1))
 486        echo "$cmt" > "$dotest/cmt.$msgnum"
 487done
 488
 489echo 1 >"$dotest/msgnum"
 490echo $msgnum >"$dotest/end"
 491
 492end=$msgnum
 493msgnum=1
 494
 495while test "$msgnum" -le "$end"
 496do
 497        call_merge "$msgnum"
 498        continue_merge
 499done
 500
 501finish_rb_merge